# Enter Markets

Enter into a list of markets - it is not an error to enter the same market more than once. In order to supply collateral or borrow in a market, it must be entered first.

**Comptroller**

```
function enterMarkets(address[] calldata sTokens) returns (uint[] memory)
```

* `msg.sender`: The account which shall enter the given markets.
* `sTokens`: The addresses of the sToken markets to enter.
* `RETURN`: For each market, returns an error code indicating whether or not it was entered. Each is 0 on success, otherwise an [Error code](/comptroller/error-codes.md).

**Solidity**

```
Comptroller troll = Comptroller(0xABCD...);
SToken[] memory sTokens = new SToken[](2);
sTokens[0] = SErc20(0x3FDA...);
sTokens[1] = SEther(0x3FDB...);
uint[] memory errors = troll.enterMarkets(sTokens);
```

**Web3 1.0**

```javascript
const troll = Comptroller.at(0xABCD...);
const sTokens = [SErc20.at(0x3FDA...), SEther.at(0x3FDB...)];
const errors = await troll.methods.enterMarkets(sTokens).send({from: ...});
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.strike.org/comptroller/enter-markets.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
